searchNodes=[{"doc":"ExOwm, OpenWeatherMap API Elixir client. This module contains main public interface of the application.","ref":"ExOwm.html","title":"ExOwm","type":"module"},{"doc":"Gets weather data of the given location with specified options.Examplesiex&gt; ExOwm.get_current_weather([%{city: &quot;Warsaw&quot;}, %{city: &quot;London&quot;, country_code: &quot;uk&quot;}], units: :metric, lang: :pl)","ref":"ExOwm.html#get_current_weather/2","title":"ExOwm.get_current_weather/2","type":"function"},{"doc":"Gets 5 day forecast data of the given location with specified options.Examplesiex&gt; ExOwm.get_five_day_forecast([%{city: &quot;Warsaw&quot;}, %{city: &quot;London&quot;, country_code: &quot;uk&quot;}], units: :metric, lang: :pl)","ref":"ExOwm.html#get_five_day_forecast/2","title":"ExOwm.get_five_day_forecast/2","type":"function"},{"doc":"Gets historical weather data of the given location with specified options. dt should be within the last 5 days.Examplesiex&gt; ExOwm.get_historical_weather([%{lat: 52.374031, lon: 4.88969, dt: 1615546800}], units: :metric, lang: :pl)","ref":"ExOwm.html#get_historical_weather/2","title":"ExOwm.get_historical_weather/2","type":"function"},{"doc":"Gets 1 to 16 days forecast data of the given location with specified options.Examplesiex&gt; ExOwm.get_sixteen_day_forecast([%{city: &quot;Warsaw&quot;}, %{city: &quot;London&quot;, country_code: &quot;uk&quot;}], units: :metric, lang: :pl, cnt: 16)","ref":"ExOwm.html#get_sixteen_day_forecast/2","title":"ExOwm.get_sixteen_day_forecast/2","type":"function"},{"doc":"Gets weather data of the given location with specified options.Examplesiex&gt; ExOwm.get_weather([%{lat: 52.374031, lon: 4.88969}], units: :metric, lang: :pl)","ref":"ExOwm.html#get_weather/2","title":"ExOwm.get_weather/2","type":"function"},{"doc":"Current weather data API call options corresponding to OWM APIs described in official docs: http://openweathermap.org/apiThe output of the request can be specified according to below options.","ref":"ExOwm.html#t:option/0","title":"ExOwm.option/0","type":"type"},{"doc":"Keyword list of options.","ref":"ExOwm.html#t:options/0","title":"ExOwm.options/0","type":"type"},{"doc":"Current weather data API request.","ref":"ExOwm.html#t:request/0","title":"ExOwm.request/0","type":"type"},{"doc":"Current weather data API requests.","ref":"ExOwm.html#t:requests/0","title":"ExOwm.requests/0","type":"type"},{"doc":"This module contains OpenWeatherMap API related functions.","ref":"ExOwm.Api.html","title":"ExOwm.Api","type":"module"},{"doc":"Prepares request string basing on given params, calls OWM API, parses and decodes the answers.","ref":"ExOwm.Api.html#send_and_parse_request/3","title":"ExOwm.Api.send_and_parse_request/3","type":"function"},{"doc":"","ref":"ExOwm.Application.html","title":"ExOwm.Application","type":"module"},{"doc":"Callback implementation for Application.start/2.","ref":"ExOwm.Application.html#start/2","title":"ExOwm.Application.start/2","type":"function"},{"doc":"","ref":"ExOwm.Cache.html","title":"ExOwm.Cache","type":"module"},{"doc":"A convenience function for retrieving the current generations.","ref":"ExOwm.Cache.html#generations/0","title":"ExOwm.Cache.generations/0","type":"function"},{"doc":"A convenience function for creating new generations.","ref":"ExOwm.Cache.html#new_generation/1","title":"ExOwm.Cache.new_generation/1","type":"function"},{"doc":"A convenience function for retrieving the newer generation.","ref":"ExOwm.Cache.html#newer_generation/0","title":"ExOwm.Cache.newer_generation/0","type":"function"},{"doc":"A convenience function for reset the GC timer.","ref":"ExOwm.Cache.html#reset_generation_timer/0","title":"ExOwm.Cache.reset_generation_timer/0","type":"function"},{"doc":"This module is a GenServer implementation created for handling concurrent worker task coordination.","ref":"ExOwm.CurrentWeather.Coordinator.html","title":"ExOwm.CurrentWeather.Coordinator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"ExOwm.CurrentWeather.Coordinator.html#child_spec/1","title":"ExOwm.CurrentWeather.Coordinator.child_spec/1","type":"function"},{"doc":"","ref":"ExOwm.CurrentWeather.Coordinator.html#get_weather/2","title":"ExOwm.CurrentWeather.Coordinator.get_weather/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"ExOwm.CurrentWeather.Coordinator.html#init/1","title":"ExOwm.CurrentWeather.Coordinator.init/1","type":"function"},{"doc":"","ref":"ExOwm.CurrentWeather.Coordinator.html#start_link/1","title":"ExOwm.CurrentWeather.Coordinator.start_link/1","type":"function"},{"doc":"Current Weather Worker task implementation.","ref":"ExOwm.CurrentWeather.Worker.html","title":"ExOwm.CurrentWeather.Worker","type":"module"},{"doc":"Returns current weather for a specific location and given options. Checks whether request has been already cached, if not it sends the request to OWM API and caches it with specific TTL.","ref":"ExOwm.CurrentWeather.Worker.html#get_current_weather/2","title":"ExOwm.CurrentWeather.Worker.get_current_weather/2","type":"function"},{"doc":"This module is a GenServer implementation created for handling concurrent worker task coordination.","ref":"ExOwm.FiveDayForecast.Coordinator.html","title":"ExOwm.FiveDayForecast.Coordinator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"ExOwm.FiveDayForecast.Coordinator.html#child_spec/1","title":"ExOwm.FiveDayForecast.Coordinator.child_spec/1","type":"function"},{"doc":"","ref":"ExOwm.FiveDayForecast.Coordinator.html#get_weather/2","title":"ExOwm.FiveDayForecast.Coordinator.get_weather/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"ExOwm.FiveDayForecast.Coordinator.html#init/1","title":"ExOwm.FiveDayForecast.Coordinator.init/1","type":"function"},{"doc":"","ref":"ExOwm.FiveDayForecast.Coordinator.html#start_link/1","title":"ExOwm.FiveDayForecast.Coordinator.start_link/1","type":"function"},{"doc":"Five Day Forecast Worker task implementation.","ref":"ExOwm.FiveDayForecast.Worker.html","title":"ExOwm.FiveDayForecast.Worker","type":"module"},{"doc":"Returns five day weather forecast for a specific location and given options. Checks whether request has been already cached, if not it sends the request to OWM API and caches it with specific TTL.","ref":"ExOwm.FiveDayForecast.Worker.html#get_five_day_forecast/2","title":"ExOwm.FiveDayForecast.Worker.get_five_day_forecast/2","type":"function"},{"doc":"This module is a GenServer implementation created for handling concurrent worker task coordination.","ref":"ExOwm.HistoricalWeather.Coordinator.html","title":"ExOwm.HistoricalWeather.Coordinator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"ExOwm.HistoricalWeather.Coordinator.html#child_spec/1","title":"ExOwm.HistoricalWeather.Coordinator.child_spec/1","type":"function"},{"doc":"","ref":"ExOwm.HistoricalWeather.Coordinator.html#get_weather/2","title":"ExOwm.HistoricalWeather.Coordinator.get_weather/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"ExOwm.HistoricalWeather.Coordinator.html#init/1","title":"ExOwm.HistoricalWeather.Coordinator.init/1","type":"function"},{"doc":"","ref":"ExOwm.HistoricalWeather.Coordinator.html#start_link/1","title":"ExOwm.HistoricalWeather.Coordinator.start_link/1","type":"function"},{"doc":"Five Day Forecast Worker task implementation.","ref":"ExOwm.HistoricalWeather.Worker.html","title":"ExOwm.HistoricalWeather.Worker","type":"module"},{"doc":"Returns five day weather forecast for a specific location and given options. Checks whether request has been already cached, if not it sends the request to OWM API and caches it with specific TTL.","ref":"ExOwm.HistoricalWeather.Worker.html#get_historical_weather/2","title":"ExOwm.HistoricalWeather.Worker.get_historical_weather/2","type":"function"},{"doc":"Request string creation.","ref":"ExOwm.RequestString.html","title":"ExOwm.RequestString","type":"module"},{"doc":"Builds request string basing on provided params.","ref":"ExOwm.RequestString.html#build/3","title":"ExOwm.RequestString.build/3","type":"function"},{"doc":"This module is a GenServer implementation created for handling concurrent worker task coordination.","ref":"ExOwm.SixteenDayForecast.Coordinator.html","title":"ExOwm.SixteenDayForecast.Coordinator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"ExOwm.SixteenDayForecast.Coordinator.html#child_spec/1","title":"ExOwm.SixteenDayForecast.Coordinator.child_spec/1","type":"function"},{"doc":"","ref":"ExOwm.SixteenDayForecast.Coordinator.html#get_weather/2","title":"ExOwm.SixteenDayForecast.Coordinator.get_weather/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"ExOwm.SixteenDayForecast.Coordinator.html#init/1","title":"ExOwm.SixteenDayForecast.Coordinator.init/1","type":"function"},{"doc":"","ref":"ExOwm.SixteenDayForecast.Coordinator.html#start_link/1","title":"ExOwm.SixteenDayForecast.Coordinator.start_link/1","type":"function"},{"doc":"Sixteen Day Forecast Worker task implementation.","ref":"ExOwm.SixteenDayForecast.Worker.html","title":"ExOwm.SixteenDayForecast.Worker","type":"module"},{"doc":"Returns sixteen day weather forecast for a specific location and given options. Checks whether request has been already cached, if not it sends the request to OWM API and caches it with specific TTL.","ref":"ExOwm.SixteenDayForecast.Worker.html#get_sixteen_day_forecast/2","title":"ExOwm.SixteenDayForecast.Worker.get_sixteen_day_forecast/2","type":"function"},{"doc":"Standard Supervisor implementation. The only child is Coordinator GenSever used for concurrent OWM API calls handling.","ref":"ExOwm.Supervisor.html","title":"ExOwm.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"ExOwm.Supervisor.html#child_spec/1","title":"ExOwm.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"ExOwm.Supervisor.html#init/1","title":"ExOwm.Supervisor.init/1","type":"function"},{"doc":"","ref":"ExOwm.Supervisor.html#start_link/1","title":"ExOwm.Supervisor.start_link/1","type":"function"},{"doc":"This module is a GenServer implementation created for handling concurrent worker task coordination.","ref":"ExOwm.Weather.Coordinator.html","title":"ExOwm.Weather.Coordinator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"ExOwm.Weather.Coordinator.html#child_spec/1","title":"ExOwm.Weather.Coordinator.child_spec/1","type":"function"},{"doc":"","ref":"ExOwm.Weather.Coordinator.html#get_weather/2","title":"ExOwm.Weather.Coordinator.get_weather/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"ExOwm.Weather.Coordinator.html#init/1","title":"ExOwm.Weather.Coordinator.init/1","type":"function"},{"doc":"","ref":"ExOwm.Weather.Coordinator.html#start_link/1","title":"ExOwm.Weather.Coordinator.start_link/1","type":"function"},{"doc":"Current Weather Worker task implementation.","ref":"ExOwm.Weather.Worker.html","title":"ExOwm.Weather.Worker","type":"module"},{"doc":"Returns current weather for a specific location and given options. Checks whether request has been already cached, if not it sends the request to OWM API and caches it with specific TTL.","ref":"ExOwm.Weather.Worker.html#get_weather/2","title":"ExOwm.Weather.Worker.get_weather/2","type":"function"},{"doc":"ExOwm Fast, industrial strength Open Weather Map interface for Elixir platforms.","ref":"readme.html","title":"ExOwm","type":"extras"},{"doc":"Add ExOwm as a dependency to your mix.exs file:defp deps() do [{:ex_owm, &quot;~&gt; 1.2.3&quot;}] end","ref":"readme.html#installation","title":"ExOwm - Installation","type":"extras"},{"doc":"Please re-factor your configuration and paste below one once again as module naming (specifically the order) has slightly changed!","ref":"readme.html#upgrade-from-1-0-x","title":"ExOwm - Upgrade from 1.0.X","type":"extras"},{"doc":"In order to be able to use OWM APIs, you need to register free account and get free API KEY. After obtaining the key, please set environmental variable called OWM_API_KEY and set the value to your API KEY.If you are going to use this application as a dependency in your own project, you will need to copy and paste below configuration to your config/config.exs file:config :ex_owm, api_key: System.get_env(&quot;OWM_API_KEY&quot;)..and you are ready to go!","ref":"readme.html#configuration","title":"ExOwm - Configuration","type":"extras"},{"doc":"ExOwm is currently handling the following main OpenWeatherMap APIs: Current weather data One Call API One Call API History 5 day / 3 hour forecast 1 - 16 day / daily forecastPlease note that with standard (free) license / API key you may be limited with amount of requests per minute and may not be able to access 1 - 16 day / daily forecast. Please refer to OpenWeatherMap license plans.There are three main public interface functions for each API and they accepts the same set of two params - a list of location maps and a keyword list of options.Sample API calls may look following:ExOwm.get_current_weather([%{city: &quot;Warsaw&quot;}, %{city: &quot;London&quot;, country_code: &quot;uk&quot;}], units: :metric, lang: :pl) [{:ok, %{WARSAW_DATA}}, {:ok, %{LONDON_DATA}}] ExOwm.get_five_day_forecast([%{city: &quot;Warsaw&quot;}, %{city: &quot;London&quot;, country_code: &quot;uk&quot;}], units: :metric, lang: :pl) [{:ok, %{WARSAW_DATA}}, {:ok, %{LONDON_DATA}}] ExOwm.get_sixteen_day_forecast([%{city: &quot;Warsaw&quot;}, %{city: &quot;unknown City Name&quot;, country_code: &quot;uk&quot;}], units: :metric, lang: :pl, cnt: 16) [{:ok, %{WARSAW_DATA}}, {:error, :not_found, %{&quot;cod&quot; =&gt; &quot;404&quot;, &quot;message&quot; =&gt; &quot;city not found&quot;}}] yesterday = DateTime.utc_now() |&gt; DateTime.add(24 * 60 * 60 * -1, :second) |&gt; DateTime.to_unix() ExOwm.get_historical_weather([%{lat: 52.374031, lon: 4.88969, dt: yesterday}]) [{:ok, %{CITY_DATA}}] Please refer to official docs for more details.","ref":"readme.html#basic-usage","title":"ExOwm - Basic Usage","type":"extras"},{"doc":"ExOwm is using cool features like: concurrent API calls super fast generational caching access to main OWM APIs!It means that each location entry passed within the list spawns separate task (Elixir worker process) which is checking whether the request has been already sent within a time interval, if yes, it's fetching the result from cache. Otherwise it sends API query, saves the result in cache and returns the data.","ref":"readme.html#overview","title":"ExOwm - Overview","type":"extras"},{"doc":"Add Historical Data API","ref":"readme.html#to-do","title":"ExOwm - To do","type":"extras"},{"doc":"This project is MIT licensed. Please see the LICENSE.md file for more details.","ref":"readme.html#license","title":"ExOwm - License","type":"extras"}]